--$Name: Инстедоз №6$
--$Version: 0.35$
--$Author: Сообщество Instead$
--$Info: Сборник игр, выпущенных в рамках\nИнстедоза №6.\n\nПодробности на форуме instead-games.ru$

require "fmt"
require "parser/mp-ru"
require "snd"
require "prefs"
require "autotheme"

mp.togglehelp = true
mp.autohelp = false
mp.autohelp_limit = 8
mp.compl_thresh = 1
mp.undo = 0
prefs.game = 0

game.dsc = fmt.b("Инстедоз №6 \"Парсердоз\"") ..fmt.em( "^Версия 0.35^Авторы: Пётр Косых, Irremann, Dwarf Vader, Артур Айвазян, Андрей Лобанов^^В сборнике использована следующая музыка:^• Nagz -- 98 little windows;^• Minomus -- Winds of Fjords;^• Liam the Lemming -- AlieN EartH;^• Necros -- Andante;^• Muffler -- Blues;^• Falcon -- Cosmic Outflow 2;^• Meo -- Sleeping Waste;^• Manwe -- Under Laziness.^^Если вам необходима справка по игре, наберите \"помощь\".")

function init()
   pl.word = -"я/мр,1л"
   pl.room = "спальня"
   snd.music("mus/98 little windows.xm")
end

function start()
   if prefs.game == 1 then
	  _"лампа".on = true
	  prefs.game = 0
	  prefs:store()
	  walk "оглавление"
   end
end	  

room {
	  -"спальня,комната",
   nam = "спальня",
   seen = false,
   dsc = function(s)
	  if not s.seen then
		 s.seen = true
		 return "Как всегда перед важным днём я не могу уснуть."
	  else
		 return false
	  end
   end,
   obj = {
	  obj {
			-"кровать",
		 nam = "кровать",
		 description = "Моя кровать. Удобная и уютная.",
		 before_LookUnder = function(s)
			if _"лампа".on then
			   return "Под кроватью лежит одинокий носок."
			else
			   return "В темноте ничего не видно."
			end
		 end,
		 before_Take = "Тяжёлая.",
		 obj = {
			obj {
				  -"носок",
			   nam = "носок",
			   description = "Вот куда делся мой второй носок, который я никак не мог найти утром!",
			}:attr "scenery,~animate":disable(),
		 },
	  }:attr "static,supporter,enterable",
	  obj {
			-"стол,столик",
		 nam = "стол",
		 dscription = "Прикроватный столик.",
		 before_Take =  "Мне не нужно брать стол, чтобы лучше заснуть.",
		 obj = {
			obj {
				  -"лампа,светильник",
			   nam = "лампа",
			   on = false,
			   description = function(s)
				  local v = "Старая настольная лампа, доставшаяся мне в наследство от родителей. "
				  if s.on then
					 v = v .. "Сейчас она включена."
				  else
					 v = v .. "Сейчас она выключена."
				  end
				  return v
			   end,
			   before_Take = "Лампа хорошо стоит на столике. Не хочу её переставлять.",
			   before_Burn = function(s)
				  if not s.on then
					 s.on = true
					 enable "носок"
					 return "Я включил настольную лампу. Комнату наполнил приятный мягкий свет."
				  else
					 return "Лампа уже включена."
				  end
			   end,
			   before_SwitchOn = function(s)
				  return s:before_Burn()
			   end,
			   before_SwitchOff = function(s)
				  if s.on then
					 s.on = false
					 disable "носок"
					 return "Я выключил лампу. Комната погрузилась в темноту, в которой угадываются силуэты предметов."
				  else
					 return "Лампа уже выключена."
				  end
			   end,
			}:attr "static",
			obj {
				  -"книга,книжка",
			   nam = "книга",
			   description = "Недавно мне попал в руки этот небольшой сборник рассказов. Люблю такие литературные артефакты.",
			   before_Exam = function()
				  if _"лампа".on then
					 walk "оглавление"
				  else
					 return "В темноте не могу разобрать ни строчки."
				  end
			   end,
			   before_Open = function(s)
				  return s.before_Exam()
			   end,
			},
		 },
	  }:attr "supporter,enterable,static",
	  obj {
			-"окно",
		 nam = "окно",
		 description = "За окном горят редкие окна ночных жителей соседних домов.",
	  }:attr "static",
   },
}

room {
   nam = "оглавление",
   dsc = "\"Один день лета\". Пётр Косых^\"Судный день\". Пётр Косых^\"Пробуждение\". Irremann^\"Возвращение\". Irremann^\"CUMP: История 1\". Артур Айвазян^\"Ностальгия\". Zlobot^\"Лондон 1884\". Андрей Лобанов",
   obj = {
	  obj {
			-"лондон 1884,лондон",
		 dsc = "Лондон 1884^",
		 before_Exam = function()
			mp:clear()
			mp:cls_prompt()
			gamefile("london.lua", true)
		 end,
	  }:attr "scenery",
	  obj {
			-"один день лета,один день,один",
		 nam = "один день лета",
		 dsc = "Один день лета^",
		 before_Exam = function()
			mp:clear()
			mp:cls_prompt()
			gamefile("summerday.lua", true)
		 end,
	  }:attr "scenery",
	  obj {
			-"пробуждение",
		 nam = "пробуждение",
		 before_Exam = function()
			mp:clear()
			mp:cls_prompt()
			gamefile("awaking.lua", true)
		 end,
	  }:attr "scenery",
	  obj {
			-"cump,cump: история 1",
		 nam = "cump: история 1",
		 before_Exam = function()
			mp:clear()
			mp:cls_prompt()
			gamefile("cump.lua", true)
		 end,
	  }:attr "scenery",
	  obj {
			-"судный день,судный",
		 nam = "судный день",
		 before_Exam = function()
			mp:clear()
			mp:cls_prompt()
			gamefile("deadhand.lua", true)
		 end,
	  }:attr "scenery",
	  obj {
			-"ностальгия",
		 nam = "ностальгия",
		 before_Exam = function()
			mp:clear()
			mp:cls_prompt()
			gamefile("nostalgia.lua", true)
		 end,
	  }:attr "scenery",
	  obj {
			-"возвращение",
		 nam = "возвращение",
		 before_Exam = function()
			mp:clear()
			mp:cls_prompt()
			gamefile("returning.lua", true)
		 end,
	  }:attr "scenery",
   },
   out_to = "спальня",
}
